#include "Board.h"



Board::Board (const int w, const int h)
{
    width = w;
    height = h;

    for (int i = 0; i < width * height; i++) pieces.push_back (0);
}



Board::~Board ()
{
    pieces.clear();
}



int Board::GetCell (const int x, const int y)
{
    if (y < 0)
    {
        return 0;   // Always clear above the top of the level 
    }
    else if (x < 0 || x >= width || y >= height)
    {
        return 1;   // Always full to the left, right, or below the level
    }
    return pieces[x + y * width];
}



int Board::GetWidth (void)  { return width; }
int Board::GetHeight (void) { return height; }



void Board::Clear (void)
{
    pieces.clear ();
    for (int i = 0; i < width * height; i++) pieces.push_back (0);
}



void Board::SetCell (const int x, const int y, const int cell)
{
    if (x >= 0 && x < width && y >= 0 && y < height)
    {
        pieces[x + y * width] = cell;
    }
}



// Display a text representation of the board to stdout for debugging.
void Board::Print (void)
{
    for (int y = 0; y < height; y++)
    {
        for (int x = 0; x < width; x++)
        {
            cout << GetCell (x,y);
        }
        cout << endl;
    }

}

