// Holds information about the 3D graphics sapce 

#ifndef GRAPHICS_OPENGL_H
#define GRAPHICS_OPENGL_H

#include "Vector3.h"

class GraphicsOpenGL
{
private:

    Vector3 curColor, curColor2, backColor;     // Drawing colors
    int windowWidth, windowHeight;
    int windowHandle;

public:

    GraphicsOpenGL      (const int w, const int h, const char * title);
    ~GraphicsOpenGL     ();

    void SetColor       (const float x, const float y, const float z);
    void SetColor       (const Vector3 col);
    void SetColor2      (const Vector3 col);
    void SetBackColor   (const Vector3 col);

    void SetColors (const float c1x, const float c1y, const float c1z, 
            const float c2x, const float c2y, const float c2z, const float c3x, 
            const float c3y, const float c3z);

    int GetWidth        (void);
    int GetHeight       (void);

//    void Refresh        (void);

    void Clear          (void);

    void ClearArea      (const int x, const int y, const int width,
                        const int height);

    // void Msg            (const char * msg);
    // void ErrMsg         (const char * msg);

//    void ShowMouse      (void);
//    void HideMouse      (void);


/*
    // 2D routines - implement later maybe

    void Rectangle      (const int x, const int y, const int width,
                        const int height);

    void FillRectangle  (const int x, const int y, const int width,
                        const int height);

    void Pixel          (const int x, const int y, const bool useXor);

    void DottedHLine    (const int x, const int y, const int length,
                        const int dotLength, const bool useXor);
    void DottedVLine    (const int x, const int y, const int length,
                        const int dotLength, const bool useXor);

    void DrawImage      (const int x, const int y, const bool useMask,
                        BITMAP * image);
    void DrawImagePart  (const int x, const int y, const int width,
                        const int height, BITMAP * image);

    void Text           (const int x, const int y, const char * text);
    void TransText      (const int x, const int y, const char * text);
    void LayeredTransText   (const int x, const int y, const char * text);
    
    void GetString          (char *returnStr, const int x, const int y,
                            const char *defaultStr,
                            const unsigned int maxLength);

    void GetStringPrompt    (char * returnStr, const int x,
                            const int y, const char * defaultStr,
                            const char * promptStr,
                            const unsigned int maxLength);

    int GetNumberPrompt     (const int x, const int y, const int min,
                            const int max, const int defaultNumber,
                            const char * promptStr,
                            const unsigned int maxLength);

    bool LoadBackground     (const char * filename);

    void DrawBackground     (void);
*/
};

#endif

