#include "Keyboard.h"
#include <allegro.h>



Keyboard::Keyboard (void)
{
    int i;

    install_keyboard ();

    keyDown = new bool [numKeys];
    keyNewlyDown = new bool [numKeys];
    keyNewlyReleased = new bool [numKeys];

    for (i = 0; i < numKeys; i++)
    {
        keyDown[i] = false;
        keyNewlyDown[i] = false;
        keyNewlyReleased[i] = false;
    }
}



Keyboard::~Keyboard()
{
    delete [] keyDown;
    delete [] keyNewlyDown;
    delete [] keyNewlyReleased;
}



void Keyboard::ScanInput (void)
{
    int i;
    
    // Tell the device we need keypress data if necessary
    if (keyboard_needs_poll()) poll_keyboard ();
   
    // Loop through each of our defined keys and check if they are pressed
    for (i = 0; i < numKeys; i++)
    {
        if (key[keyCodes[i]])   // Key pressed
        {
            keyNewlyDown[i] = !keyDown[i];
            keyDown[i] = true;
            keyNewlyReleased[i] = false;
        }
        else    // Key not presed
        {
            keyNewlyReleased[i] = keyDown[i];
            keyDown[i] = false;
            keyNewlyDown[i] = false;
        }
    }
}



bool Keyboard::GetKeyDown (usedKey key)         { return keyDown[key]; }
bool Keyboard::GetKeyNewlyDown (usedKey key)	{ return keyNewlyDown[key]; }
bool Keyboard::GetKeyNewlyReleased (usedKey key){ return keyNewlyReleased[key];}

