#include <allegro.h>

#ifndef KEYBOARD_H
#define KEYBOARD_H
    

// The number of keys in our pressed arrays
const int numKeys = 15;

// List of all of our key types
typedef enum {
    ESC_KEY = 0,
    BACKSPACE_KEY = 1,
    UP_KEY = 2, 
    DOWN_KEY = 3,
    LEFT_KEY = 4, 
    RIGHT_KEY = 5, 
    S_KEY = 6, 
    L_KEY = 7,
    H_KEY = 8,
    R_KEY = 9,
    CTRL_KEY = 10,
    F1_KEY = 11,
    EQUALS_KEY = 12,
    HOME_KEY = 13,
    END_KEY = 14
} usedKey;

// Array of key codes maps each of our defined key types to an allegro key
// Must be listed in the same order as the usedKey enum above!
const int keyCodes [] = {
    KEY_ESC,
    KEY_BACKSPACE,
    KEY_UP, 
    KEY_DOWN,
    KEY_LEFT, 
    KEY_RIGHT, 
    KEY_S, 
    KEY_L,
    KEY_H,
    KEY_R,
    KEY_LCONTROL,
    KEY_F1,
    KEY_EQUALS,
    KEY_HOME,
    KEY_END
};


class Keyboard  
{
private:

    // Array of whether or not keys are pressed
    bool * keyDown;         
    bool * keyNewlyDown;
    bool * keyNewlyReleased;

    bool initialized;

public:
   
    Keyboard                    (void);
    ~Keyboard                   (void);

    void ScanInput              (void);

    bool GetKeyDown             (usedKey key);
    bool GetKeyNewlyDown        (usedKey key);
    bool GetKeyNewlyReleased    (usedKey key);
};

#endif

