#ifndef LEVEL_H
#define LEVEL_H

const int LEVEL_TITLE_LENGTH = 50;

class Level  
{
private:

    int width, height;      // Size of the level in cells
    int number;
    char * title;
    char * filename;
    int ** tiles;           // Actual level data

    void Initialize     (const int w, const int h);
    void Clear          (void);
    void Copy           (Level * other);

public:

    Level               (const int w, const int h);   
    Level               (Level * other);
    ~Level              ();

    void Save           (void);
    void Load           (void);
    void ClearTilesTo   (int which);

    void SetTitle       (const char * str);
    void SetFilename    (const char * str);
    void SetNumber      (const int num);
    void SetTile        (const int x, const int y, const int tile);
    void Resize         (const int newWidth, const int newHeight,
                        const int emptyTile);

    char * GetTitle     (void);
    char * GetFilename  (void);
    int GetWidth        (void);
    int GetHeight       (void);
    int GetNumber       (void);
    int GetTile         (const int x, const int y);
};

#endif

