#ifndef LIGHT_H
#define LIGHT_H

#include "vector3.h"


class Light  
{
private:
    
    Vector3 position;
    Vector3 color;
    float zeroPos [4];      // Location of origin (homogeneous representation)
    float dirI [4];         // Direction of unit vector I (point at infinity)

public:

    Light ();
    void SetLighting (float r, float g, float b);
    void AdjustLighting ();
    void Draw ();           // Declares light to GL
};

#endif

