#include "Mouse.h"
#include <allegro.h>



Mouse::Mouse (void)
{
    install_mouse ();
    install_timer ();

    leftClick = newLeftClick = newLeftRelease = 
        rightClick = newRightClick = newRightRelease = false;
}



// Getters
int Mouse::GetX (void)                  { return x; }
int Mouse::GetY (void)                  { return y; }
bool Mouse::GetLeftClick (void)         { return leftClick; }
bool Mouse::GetRightClick (void)        { return rightClick; }
bool Mouse::GetNewLeftClick (void)      { return newLeftClick; }
bool Mouse::GetNewRightClick (void)     { return newRightClick; }
bool Mouse::GetNewLeftRelease (void)    { return newLeftRelease; }
bool Mouse::GetNewRightRelease (void)   { return newRightRelease; }
int Mouse::GetNumWheelRolls (void)      { return numWheelRolls; }



void Mouse::SetPosition (const int x, const int y)  { position_mouse (x, y); }



void Mouse::ScanInput (void)
{
    if (mouse_needs_poll()) poll_mouse();
    
    x = mouse_x;
    y = mouse_y;

    if (mouse_b & 1)
    {
        newLeftClick = !leftClick;
        leftClick = true;
    }
    else
    {
        newLeftRelease = leftClick;
        leftClick = false;
    }

    if (mouse_b & 2)
    {
        newRightClick = !rightClick;
        rightClick = true;
    }
    else
    {
        newRightRelease = rightClick;
        rightClick = false;
    }
    
    if (mouse_z != 0)
    {
	    numWheelRolls = mouse_z;
	    position_mouse_z(0);
    }
    else
    {
	    numWheelRolls = 0;
    }
}



