#ifndef MOUSE_H
#define MOUSE_H

class Mouse  
{
private:

    // Pixel location of the cursor
    int x, y;

    // Whether or not the indicated mouse buttons are (newly) clicked/released
    bool leftClick, rightClick,
        newLeftClick, newRightClick,
        newLeftRelease, newRightRelease;
   
    // Number of clicks that the mouse wheel has been rolled since the last
    // input scan.
    int numWheelRolls;

public:

    Mouse                   (void);

    // Getters
    int GetX                (void);
    int GetY                (void);
    bool GetLeftClick       (void);
    bool GetRightClick      (void);
    bool GetNewLeftClick    (void);
    bool GetNewRightClick   (void);
    bool GetNewLeftRelease  (void);
    bool GetNewRightRelease (void);
    int GetNumWheelRolls    (void);

    void SetPosition        (const int x, const int y);

    // Scan the mouse input and refresh the variables
    void ScanInput (void);
};

#endif 

