#ifndef TIMER_H
#define TIMER_H

#include <sys/time.h>

class Timer
{
private:
    double triggerSeconds;          // Number of seconds before timer triggers
    struct timeval startTime;       // Saved start time to check against
    bool initialized;               // Whether or not a length has been set
    bool trigger;                   // If set, trigger the timer

    int TimevalSubtract (struct timeval *result, struct timeval *x,
        struct timeval *y);

public:
    Timer ();                                   // Marks timer as non-init.
    Timer (const double numSeconds);            // Set the timer length on init
    void SetLength (const double numSeconds);   // Start the timer length
    void Reset (void);                          // Save the current # of ticks
    void Delay (const double numSeconds);       // Save the current # of ticks
    void Trigger (void);                        // Tells the timer to go off
    inline double GetSecondsElapsed (void);     // Seconds elapsed since reset
    bool HasTriggered (void);
};

#endif
