#ifndef VECTOR3_H
#define VECTOR3_H

class Vector3  
{
public:

    float x, y, z;      // Generally bad practice to have public member
                        // variables but these ones are here to keep code small

    // Constructors
    Vector3         ();
    Vector3         (float X, float Y, float Z);

    // Accessor functions
    float GetX      ();
    float GetY      ();
    float GetZ      ();
    void SetX       (float X);
    void SetY       (float Y);
    void SetZ       (float Z);
    void SetXYZ     (float X, float Y, float Z);

    //
    // Linear algebra functions - change this vector by performing an operation
    // that includes this vector
    //
    void Add        (Vector3 a);
    void Subtract   (Vector3 a);
    void Negate     ();
    void Scale      (float s);

    //
    // Linear algebra functions - change this vector by making it equal to the
    // result of an operation on other vectors and/or scalars
    //
    void Add        (Vector3 a, Vector3 b);
    void Subtract   (Vector3 a, Vector3 b);
    void Negate     (Vector3 a);
    void Scale      (float s, Vector3 b);
    void Cross      (Vector3 a, Vector3 b);

    // Other linear algebra functions
    void Normalize  ();                     // Normalize this vector
    float Magnitude (Vector3 a);            // Get magnitude of this vector
    float Dot       (Vector3 a);            // Get the dot product of this
                                            // vector and vector a
};

#endif

